#!/bin/bash

. ParseDico

MDIR="/usr/share/era/modeles"

## existance du fichier xml firewall
if [ ! -e $MDIR/${type_amon}.xml ]
then
	echo "!! Modèle ${type_amon}.xml non trouvé !!"
	exit 1
fi

# script de lancement du compilateur de regle (backend) era
export PYTHONPATH=/usr/share/
cd /usr/share/era/
./backend/compiler -o /etc/sysconfig/eole/firewall.tmpl -a /usr/share/era/backend/data/active_tags -d /usr/share/ead2/backend/tmp/ $MDIR/${type_amon}.xml
if [ $? -eq 1 ]; then
	exit 1
fi

## gestion de la qos
./backend/qos_era_externe $MDIR/${type_amon}.xml

## authentification nufw
# instanciation "manuelle" du script de firewall
/usr/share/creole/creolecat.py  -o /sbin/lance.firewall -i /etc/eole/config.eol /etc/sysconfig/eole/firewall.tmpl

## horaires de nuit du pare-feu
/usr/share/era/backend/horaires_firewall -i /var/www/ead/tmp/horaires.txt >> /sbin/lance.firewall

# Instanciation manuelle du modele Era :
tmp_xml=$(mktemp)
/usr/share/creole/creolecat.py  -o $tmp_xml -i /etc/eole/config.eol /usr/share/era/modeles/"$type_amon".xml

# script de generation d'ACL NuFW :
if [ $active_nufw = "oui" ]; then
  if [ ! -f /etc/nufw/acls.nufw ]; then
	# si pas de fichier la première fois, on le crée
        # pour comparaison avec le fichier généré
	touch /etc/nufw/acls.nufw
  fi
cp /etc/nufw/acls.nufw /etc/nufw/acls.nufw.bak
./backend/nufw_acl_plaintext -o /etc/nufw/acls.nufw $tmp_xml
rm $tmp_xml
cmp /etc/nufw/acls.nufw /etc/nufw/acls.nufw.bak >/dev/null 2>&1 || /etc/init.d/nuauth restart | grep -q Restarting || `which invoke-rc.d` nuauth
fi

# attribution des droits au fichier lance.firewall
chmod 700 /sbin/lance.firewall

# lancement du script iptables
/sbin/lance.firewall 2>&1 | head -n 2

# ajout des règles pour les postes clients interdits
python /usr/share/era/postes_interdits.py

