# -*- coding: UTF-8 -*-
"""
Module qui définit un ensemble de fonctions utiles en rapport avec l'IHM
"""

import gtk

def destroy(widget, *args):
    widget.destroy()

def destroy_parent(widget, *args):
    widget.get_toplevel().destroy()

def create_error_dialog(msg, parent = None):

    # dlg = gtk.MessageDialog("ERREUR", parent, gtk.DIALOG_MODAL)
    dlg = gtk.MessageDialog(parent,
                            gtk.DIALOG_MODAL,
                            gtk.MESSAGE_ERROR,
                            gtk.BUTTONS_OK,
                            msg)
    dlg.action_area.set_layout(gtk.BUTTONBOX_SPREAD)
    # dlg.set_size_request(400,150)
    dlg.connect("response", destroy)
    return dlg

def create_info_dialog(msg, parent = None):
    """affiche un texte d'information et un bouton ok"""
    dlg = gtk.MessageDialog(parent,
                            gtk.DIALOG_MODAL,
                            gtk.MESSAGE_INFO,
                            gtk.BUTTONS_OK,
                            msg)
    dlg.action_area.set_layout(gtk.BUTTONBOX_SPREAD)
    # dlg.set_size_request(400,150)
    dlg.connect("response", destroy)
    return dlg

def create_yes_no_dialog(msg, parent = None):
    """affiche une boite yes or no"""
    dlg = gtk.MessageDialog(parent,
                            gtk.DIALOG_MODAL,
                            gtk.MESSAGE_WARNING,
                            gtk.BUTTONS_YES_NO,
                            msg)
    dlg.action_area.set_layout(gtk.BUTTONBOX_SPREAD)
    # dlg.connect("response", destroy)
    
    return dlg

def create_ok_cancel_dialog(msg, parent = None):
    """affiche une boite yes or no"""
    dlg = gtk.MessageDialog(parent,
                            gtk.DIALOG_MODAL,
                            gtk.MESSAGE_WARNING,
                            gtk.BUTTONS_OK_CANCEL,
                            msg)
    # dlg.connect("response", destroy)

    return dlg

def create_warning_dialog(msg, parent = None):
    """affiche une boite d'avertissement"""
    dlg = gtk.MessageDialog(parent,
                            gtk.DIALOG_MODAL,
                            gtk.MESSAGE_WARNING,
                            gtk.BUTTONS_OK,
                            msg)
    dlg.connect("response", destroy)
    return dlg

def create_about_dialog(msg, parent = None):

    dlg = gtk.MessageDialog(parent,gtk.DIALOG_MODAL, gtk.MESSAGE_INFO,gtk.BUTTONS_OK, msg)
    dlg.action_area.set_layout(gtk.BUTTONBOX_SPREAD)
    dlg.set_size_request(400,150)
    dlg.connect("response", destroy)
    return dlg


def build_image_button(title = "", image_path = "", pos = 1):
    """Construit un bouton avec un label et une image
    title : le label du bouton
    image_path : le chemin d'accès au fichier de l'image
    pos : un entier qui vaut 0 pour indiquer que le label est à gauche
    de l'image, 1 pour dire qu'il est à droite
    """
    label = gtk.Label(title)
    image = gtk.Image()
    image.set_from_file(image_path)
    hbox = gtk.HBox()
    hbox.set_border_width(2)
    if title == "":
        hbox.pack_start(image)
    elif pos == 1:
        hbox.pack_start(label)
        hbox.pack_start(image)
    else:
        hbox.pack_start(image)
        hbox.pack_start(label)
        
    button = gtk.Button()
    button.add(hbox)

    return button


def run():
    dlg = create_error_dialog("Un message d'erreur !!!")
    # dlg.connect("response", gtk.mainquit)
    dlg.show_all()
    gtk.mainloop()
    


if __name__ == '__main__':
    run()

