<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>
<xsl:output encoding="ISO-8859-1" omit-xml-declaration="no"
indent="yes" method="xml" />

<!-- ===================================================================== -->

    <!--              importation de l'ancien format xml           -->
    <!--              vers le nouveau format interne era           -->

<!-- ===================================================================== -->

<!--
#    Eole (http://eole.orion.education.fr)
#    Copyright (C) 2004

#    Se reporter  la documentation envoye avec le programme pour la notice.
#    Si elle manquait, envoyer un email  eole (eole@ac-dijon.fr)

#    distribu sous la licence GPL-2 
#    En attendant une traduction officielle de la GPL, la notice de 
#    copyright demeure en anglais.
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<xsl:template match='/' >
  <xsl:apply-templates select="bastion"/>
</xsl:template>

<xsl:template match="bastion">
<firewall name="{@nom}">
<zones>
  <xsl:apply-templates select="zone"/>
</zones>
<services>
<xsl:apply-templates
select="//service[ not(@id=preceding-sibling::service/@id) and
not(@id='tout') ]"/>
<xsl:apply-templates
select="//translation[not(@id=preceding-sibling::translation/@id) and
not(@id='tout') ]"/>
<xsl:apply-templates
select="//ping[not(@id=preceding-sibling::ping/@id) and not(@id =
'tout') ]"/>
<xsl:call-template name="tout"/>
</services>
<extremites>
<xsl:apply-templates select="//source[not(@id=preceding-sibling::source/@id)]"/>
<xsl:apply-templates select="//destination[not(@id=preceding-sibling::destination/@id)]"/>
<xsl:apply-templates select="//redirige[not(@id=preceding-sibling::redirige/@id)]"/>
</extremites>
<flux-list>
<xsl:apply-templates select="flux"/>
</flux-list>
</firewall>
</xsl:template>

<!-- ==================== conteneurs ================================================= -->

<xsl:template match="zone">
  <zone name="{text()}" level="{@niveau}" ip="{@ip}" network="{@network}" netmask="{@mask}" interface="{@interface}"/>
</xsl:template>


<xsl:template match="flux">
<flux zoneA="{extremite[1]/text()}" zoneB="{extremite[2]/text()}">
<montantes>
<xsl:apply-templates select="montant"/>
</montantes>
<descendantes>
<xsl:apply-templates select="descendant"/>
</descendantes>
</flux>
</xsl:template>

<!-- ============================  services  ====================================== -->

<xsl:template name="tout">
<service name="tout" protocol="0" id="tout" libelle="pas de description" ports="0"/>
</xsl:template>

<xsl:template match="service">
  <service name="{@id}" id="{@id}" libelle="pas de description" >

  <xsl:attribute name="protocol">
  <xsl:choose>
  <xsl:when test="@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
  <xsl:value-of select="protocole/text()"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>
  <!-- prise en compte d'un port ou d'une plage de ports -->
  <xsl:attribute name="ports">
  <xsl:choose>
      <xsl:when test="plage">
      <xsl:value-of select="plage/@basse"/><xsl:text>-</xsl:text><xsl:value-of select="plage/@haute"/>
      </xsl:when>
      <xsl:when test="port">
      <xsl:value-of select="port/text()"/>
      </xsl:when>
      <xsl:when test="@id='tout'">
      <xsl:text>0</xsl:text>
      </xsl:when>
  </xsl:choose>
  </xsl:attribute>
  </service>
</xsl:template>

<xsl:template match="translation">
  <service name="{@id}" protocol="{protocole/text()}" id="{@id}" libelle="pas de description">
  <xsl:attribute name="protocol">
  <xsl:choose>
  <xsl:when test="@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
  <xsl:value-of select="protocole/text()"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

  <xsl:attribute name="ports">
  <xsl:choose>
  <xsl:when test="@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
  <xsl:value-of select="de/text()"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

</service>
</xsl:template>

<xsl:template match="ping">
  <service name="{text()}" protocol="0" ports="0"
   id="{text()}" libelle="pas de description" />
</xsl:template>


<!-- ============================= extremites ======================================== -->


<xsl:template match="source|destination|redirige">
<extremite zone="{@extremite}" name="{@id}" libelle="pas de description"
netmask="{netmask/text()}">
<!-- attribut subnet : l'extrmit est peut-tre une seule machine -->
  <xsl:attribute name="subnet">
  <xsl:choose>
      <xsl:when test="netmask/text()='255.255.255.255'">
            <xsl:text>0</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>1</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>
<ip>
<xsl:attribute name="address">
  <xsl:choose>
    <xsl:when test="starts-with(ip/text(), '!')">
    <!-- ip address="{substring-after(ip/text(),'!')}" -->
    <xsl:value-of select="substring-after(ip/text(),'!')"/>
    </xsl:when>
    <xsl:otherwise>
    <xsl:value-of select="ip/text()"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:attribute>
</ip>
</extremite>
</xsl:template>

<!-- ========================== directives =========================================== -->

<xsl:template match="montant|descendant">
<xsl:apply-templates select="pont|barrage"/>
<xsl:apply-templates select="redirect"/>
<xsl:apply-templates select="masque"/>
<xsl:apply-templates select="dnat"/>
<xsl:apply-templates select="icmp"/>
</xsl:template>

<xsl:template match="pont|barrage">
<!-- fixme : le service par dfaut n'est pas invers -->
<directive id="{generate-id()}" service="{service/@id}" action="2" serv_inv="0" libelle="pas de description" priority="{@ordre}">
<!-- action = 2 pour un pont, action = 1 pour un barrage -->
  <xsl:attribute name="action">
    <xsl:choose>
      <xsl:when test="name()='barrage'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>2</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:attribute>

<!-- test si l'attribut optionnel est prsent ou pas -->
  <xsl:attribute name="attrs">
  <xsl:choose>
      <xsl:when test="@optionnel='oui'">
      <!-- la directive est optionnelle mais pas active -->
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
      <!-- la directive n'est pas optionnelle -->
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- gestion de l'inversion d'une extremite -->
<!-- inversion de la source -->
  <xsl:attribute name="src_inv">
  <xsl:choose>
<!-- fixme : il est plus simple de faire un starts-with(ip/text(),'!') -->
      <xsl:when test="substring(source/ip/text(),0,2)='!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>
<!-- inversion de la destination -->
  <xsl:attribute name="dest_inv">
  <xsl:choose>
      <xsl:when test="substring(destination/ip/text(),0,2)= '!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<source name="{./source/@id}"/>
<destination name="{./destination/@id}"/>
</directive>
</xsl:template>


<xsl:template match="redirect">
<!-- fixme : pb avec l'ordre des rgles -->
<directive service="{translation/@id}" action="4" serv_inv="0" libelle="pas de description">

  <xsl:attribute name="priority">
  <xsl:choose>
  <xsl:when test="@ordre">
  <xsl:value-of select="@ordre"/>
  </xsl:when>
  <xsl:otherwise>
    <xsl:variable name="gen_id" select="generate-id()"/>
    <xsl:value-of select="substring-after($gen_id, 'id')"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

  <xsl:attribute name="nat_port">
  <xsl:choose>
  <xsl:when test="translation/@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="translation/vers/text()"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- test si l'attribut optionnel est prsent ou pas -->
  <xsl:attribute name="attrs">
  <xsl:choose>
      <xsl:when test="@optionnel='oui'">
      <!-- la directive est optionnelle mais pas active -->
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
      <!-- la directive n'est pas optionnelle -->
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- gestion de l'inversion d'une extremite -->
<!-- inversion de la source -->
  <xsl:attribute name="src_inv">
  <xsl:choose>
      <xsl:when test="substring(source/ip/text(),0,2)='!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>
<!-- inversion de la destination -->
  <xsl:attribute name="dest_inv">
  <xsl:choose>
      <xsl:when test="substring(destination/ip/text(),0,2)= '!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<source name="{./source/@id}"/>
<destination name="{./destination/@id}"/>
</directive>
</xsl:template>


<xsl:template match="dnat">
<directive service="{translation/@id}" action="8" serv_inv="0" libelle="pas de description" priority="{@ordre}">

  <xsl:attribute name="nat_port">
  <xsl:choose>
  <xsl:when test="translation/@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="translation/de/text()"/>
  </xsl:otherwise>
  </xsl:choose>

  </xsl:attribute>

  <xsl:attribute name="nat_extr">
  <xsl:choose>
  <xsl:when test="redirige/@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
  <xsl:value-of select="redirige/@id"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- test si l'attribut optionnel est prsent ou pas -->
  <xsl:attribute name="attrs">
  <xsl:choose>
      <xsl:when test="@optionnel='oui'">
      <!-- la directive est optionnelle mais pas active -->
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
      <!-- la directive n'est pas optionnelle -->
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- gestion de l'inversion d'une extremite -->
<!-- inversion de la source -->
  <xsl:attribute name="src_inv">
  <xsl:choose>
      <xsl:when test="substring(source/ip/text(),0,2)='!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>
<!-- inversion de la destination -->
  <xsl:attribute name="dest_inv">
  <xsl:choose>
      <xsl:when test="substring(destination/ip/text(),0,2)= '!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<source name="{./source/@id}"/>
<destination name="{./destination/@id}"/>
</directive>
</xsl:template>

<xsl:template match="masque">
<!-- fixme : pb avec priority -->
<directive service="{translation/@id}" action="16" serv_inv="0" libelle="pas de description">

  <xsl:attribute name="priority">
  <xsl:choose>
  <xsl:when test="@ordre">
  <xsl:value-of select="@ordre"/>
  </xsl:when>
  <xsl:otherwise>
    <xsl:variable name="gen_id" select="generate-id()"/>
    <xsl:value-of select="substring-after($gen_id, 'id')"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

  <xsl:attribute name="nat_port">
  <xsl:choose>
  <xsl:when test="translation/@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="translation/de/text()"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

  <xsl:attribute name="nat_extr">
  <xsl:choose>
  <xsl:when test="redirige/@id='tout'">
  <xsl:text>0</xsl:text>
  </xsl:when>
  <xsl:otherwise>
  <xsl:value-of select="redirige/@id"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- test si l'attribut optionnel est prsent ou pas -->
  <xsl:attribute name="attrs">
  <xsl:choose>
      <xsl:when test="@optionnel='oui'">
      <!-- la directive est optionnelle mais pas active -->
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
      <!-- la directive n'est pas optionnelle -->
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- gestion de l'inversion d'une extremite -->
<!-- inversion de la source -->
  <xsl:attribute name="src_inv">
  <xsl:choose>
      <xsl:when test="substring(source/ip/text(),0,2)='!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>
<!-- inversion de la destination -->
  <xsl:attribute name="dest_inv">
  <xsl:choose>
      <xsl:when test="substring(destination/ip/text(),0,2)= '!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<source name="{./source/@id}"/>
<destination name="{./destination/@id}"/>
</directive>
</xsl:template>

<xsl:template match="icmp">
<!--  fixme : pb avec priority  -->
<directive service="{ping/text()}" action="1" serv_inv="0" libelle="pas de description">

  <xsl:attribute name="priority">
  <xsl:choose>
  <xsl:when test="@ordre">
  <xsl:value-of select="@ordre"/>
  </xsl:when>
  <xsl:otherwise>
    <xsl:variable name="gen_id" select="generate-id()"/>
    <xsl:value-of select="substring-after($gen_id, 'id')"/>
  </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

  <xsl:attribute name="action">
    <xsl:choose>
      <xsl:when test="name()='barrage'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>2</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:attribute>

<!-- test si l'attribut optionnel est prsent ou pas -->
  <xsl:attribute name="attrs">
  <xsl:choose>
      <xsl:when test="@optionnel='oui'">
      <!-- la directive est optionnelle mais pas active -->
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
      <!-- la directive n'est pas optionnelle -->
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<!-- gestion de l'inversion d'une extremite -->
<!-- inversion de la source -->
  <xsl:attribute name="src_inv">
  <xsl:choose>
      <xsl:when test="substring(source/ip/text(),0,2)='!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>
<!-- inversion de la destination -->
  <xsl:attribute name="dest_inv">
  <xsl:choose>
      <xsl:when test="substring(destination/ip/text(),0,2)= '!'">
            <xsl:text>1</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>0</xsl:text>
      </xsl:otherwise>
  </xsl:choose>
  </xsl:attribute>

<source name="{./source/@id}"/>
<destination name="{./destination/@id}"/>
</directive>
</xsl:template>



</xsl:stylesheet>