# -*- coding: UTF-8 -*-
"""Module de stockage et de manipulation structurée de données issue d'un fichier de type csv
"""
# csv est un module avec pour python2.2
import os.path , csv

## alternative simpliste ;) celle de logilab. Ils sont trop simples ces gens là.
## parsing sans module csv.py 
## string = """a,b,c"""
## def get_csv(string):
##     """return a list of string in a csv format"""
##     return [word.strip() for word in string.split(',') if word.strip()]
## print get_csv(string)


class CSVStorage:
    """Stockage des données issues de l'ead dans un fichier csv
    """
    
    def __init__(self, file="ead.csv", prepath=None):
        """
        @param file: nom court ou bien nom long du fichier de stockage
        @param prepath: chemin du fichier de sauvegarde
        """
        # si le prepath n'est pas utilisé
        self.file = file
        if prepath:
            self.prepath = prepath
        else: self.prepath = ""
        # 
        self.storage_file = os.path.join(self.prepath, self.file)
        self._load_data()

    def _load_data(self):
        """Chargement des données à partir du fichier csv
        Le fichier csv est dans le format category,url,id,name,page_url
        """
        self.data = []
        # à priori c'est une liste de rows
        csv_reader = csv.reader(file(self.storage_file, 'r'))
        
        keywords = ['tag','attrs','occurence', 'carte']

        for row in csv_reader:
            kwargs = dict(zip(keywords, row))
            self.data.append(kwargs)

    def write_data(self):
        """Ecriture dans le fichier de stockage
        """
        fd = file(self.storage_file, 'w')
        writer = csv.writer(fd)
        writer.writerows(self.data)

    def get_data(self):
        """Récupère les données à enregistrer
        """
        return self.data
    
    def set_data(self, data):
        """Renseigne les données à enregistrer
        @param data: [ ['tag','attrs','occurence'] ]
        """
        self.data = data

def _test():
    """
    optional = matrix_model.get_active_list()
    c = CSVStorage(options.gen_external_file)
    c.set_data(optional)
    c.write_data()
    """

if __name__ == "__main__":
    c = CSVStorage("test.txt")
    print c.get_data()


