# -*- coding: UTF-8 -*-
"""
Mise en forme (dump) RML des objets de la matrice.

# FIXME -- renommer matrix_model en qque chose comme directive_store 

"""

from era.noyau.constants import *
from rml import title1, title2, title3, para, page_break


def rapport(name, matrix_model):
    """L'entrée pour l'exportation en xml.
    Appelle les dump_rml des zones et des flux (et de tout le reste...)

    - name : nom (pour le nom du fichier)
    - matrix_model : le conteneur fwobjects
    """
    l = []
    # FIXME --  insérer le nom ?
    # utile pour récupérer le nom du document
    # l.append('<bastion nom="%s">' % str(name) )
    # zones
    l.append(title1(u"Liste des zones"))
    for z in matrix_model.zones :
        l.append(z.dump_rml())

    # flux
    l.append(title1(u"Liste des flux entre les différentes zones"))
    for f in matrix_model.flux :
        l.append(f.dump_rml())

    # sortie en iso-8859-1
    return "\n".join(l).encode("iso-8859-1")

# def extremite(name, ip_list,netmask):
#     """Sortie rml d'une extremité
#     """
#     EXTREMITE = """<para style="bullet">nom : %(name)s, ip : %(ip)s masque : %(masque)s </para>"""
#     return EXTREMITE % {"name":str(name), "ip_list":str(ip_list), "netmask":str(netmask)}
# 

def zone(name, level):
    """Sortie rml d'une zone
    """
    ZONE = """ <para style="bullet">
    <i>zone</i> : %(name)s,  <i>niveau</i> : %(level)s
    </para>"""

    return ZONE % {"name":name, "level":level}

def service(matrix_model):
    """Sortie rml d'un service
    """
    SERVICE = """<para style="bullet">
<i>identifiant du service</i> : %(id)s,  <i>libelle</i> : %(libelle)s
,<i>protocole</i> : %(protocol)s
</para>
"""
    return SERVICE % {"id":self.id, "libelle":self.libelle, "protocol":self.protocol}

def _table_head():
    return """<tr>
    <td>priorite</td>
    <td>source</td>
    <td>destination</td>
    <td>action</td>
    </tr>"""
#     <td>service</td>

def flux(matrix_model):
    """Sortie des flux au format rml
    """
    l = []
    d = {"zoneA":matrix_model.zoneA.name,"zoneB":matrix_model.zoneB.name}
    l.append(title1("<i>Flux</i>  : %(zoneA)s-%(zoneB)s" % d))
    l.append(para("<i>extremites</i>: %(zoneA)s et %(zoneB)s" % d))

    l.append(title2("Flux montants"))
    if len(matrix_model.up_directives_list()) :
        for directive in matrix_model.up_directives_list():
            l.append(directive.dump_rml())
            # l.append(str(directive.as_list()))
    else:
        l.append(para("(aucune directive dans ce flux)"))
    l.append(page_break())
    l.append(title2("Flux descendants"))

    if len(matrix_model.down_directives_list()) :        
##         l.append(_table_head())
##         l.append("""<blockTable  style="myBlockTableStyle">""")
        for directive in matrix_model.down_directives_list():
            l.append(directive.dump_rml())
            # l.append(str(directive.as_list()))
##         l.append("""</blockTable><spacer length="15"/>""")
    else:
        l.append(para("(Aucune directive dans ce flux)"))

    return '\n'.join(l)

def directive(liste):
    libelle = liste.pop()
    service = liste.pop()
    l = []
    l.append(title3("Detail de la directive : " + libelle))
    l.append("""<blockTable  style="myBlockTableStyle">""")
    l.append(_table_head())
    l.append("<tr>")
    for i in liste : 
        l.append("<td>%s</td>" % str(i).encode("iso-8859-1") )
    l.append("</tr>")
    l.append("""</blockTable><spacer length="5"/>""")
    l.append ("""<para style="bullet">%s</para><spacer length="15"/>""" % service)
    return  "\n".join(l)
        
## def directive(matrix_model):
##     """Mettre ici un équivalent de _write_rule...
##     """
##     l = []
##     l.append("<tr>")
##     for i in _filtre(matrix_model):
##         l.append("<td>%s</td>" % i )
##     l.append("</tr>")
##     return  "\n".join(l)

## def _filtre(matrix_model):
##     """Exportation en rml des directives
##     """
##     # type de la directive
##     if not matrix_model.service_group and matrix_model.service.protocol == "ICMP":
##         # règle icmp
##         type = 'icmp'
##     elif matrix_model.action == ACTION_ALLOW or matrix_model.action == ACTION_DENY :
##         # règle standard (autoriser - interdire)
##         type = 'std'
##     elif matrix_model.action == ACTION_MASK :
##         # règle de masque
##         type = 'masque'
##     elif matrix_model.action == ACTION_FORWARD :
##         # règle redirect
##         type = 'redirect'
##     elif matrix_model.action == ACTION_DNAT :
##         # règle dnat
##         type = 'dnat'

##     yield str(type)

##     # liste d'extremité source
##     for src in matrix_model.src_list:
##         # une extremité est peut-être un groupe d'extrémité
##         yield str(src.name)
##         for ip_src in src.ip_list:
##             # liste d'extrémtié destination
##             for dest in matrix_model.dest_list:
##                 yield str(dest.name)
##                 # une extremité est peut-être un groupe d'extrémité
##                 for ip_dest in dest.ip_list:
##                     # s'il y a un nat_extr
##                     if matrix_model.nat_extr :
##                         yield "oui"
##                         # yield "nat_extr : " + str(matrix_model.nat_extr.name)
##                         for ip_nat in matrix_model.nat_extr.ip_list :
##                             # un service ou un groupe de services
##                             if matrix_model.service_group:
##                             # FIXME -- il est possible d'imbriquer les services et groupes de services, (avec __iter__)
##                             # l'objet service est en fait un groupe de services
##                                 for serv in matrix_model.service.services :
##                                     yield str(serv.name)
##                             else :
##                                 # l'objet service est... un service
##                                 yield str(matrix_model.service.name)
##                     # s'il n'y pas de nat_extr
##                     else :
##                         yield "non"
##                         # un service ou un groupe de services
##                         if matrix_model.service_group:
##                         # l'objet service est en fait un groupe de services
##                             for serv in matrix_model.service.services :
##                                 yield str(serv.name)
##                         else :
##                             # l'objet service est... un service
##                             yield str(matrix_model.service.name)

## def _write_rule_rml(matrix_model, rule_elts) :
##     """Sortie rml d'une seule règle
##     rule_elts : le dico qui a stocké les données d'une règle
##     """
##     """
##     # FIXME -- mettre au format rml
##     # FIXME -- ça fait encore appel à _write_as_translation 
##     """

##     l = []
##     # le nom de la balise conteneur
##     if rule_elts['type'] == 'std' : 
##         if matrix_model.is_montante() :
##             elt_name = "pont"
##         else :
##             elt_name = "barrage"
##     else :
##         # le nom de la balise conteneur est précisément le nom du type
##         elt_name = rule_elts['type']

##     # définition de l'attribut optionnel pour la règle
##     if matrix_model.is_optional() :
##         optionnel = 'oui'
##     else :
##         optionnel = 'non'

##     l.append("""<tr>""")
##     l.append("<td>%s</td>"% \
##              (matrix_model.libelle))
##     # la source
##     # test sur l'inversion
##     # FIXME -- test sur l'inversion 
##     if matrix_model.src_inv :
##         rule_elts['ip_src'] = "! " + rule_elts['ip_src']
##     l.append('<td>%s</td><td>%s</td>'% \
##              (rule_elts['src'].name,
##               rule_elts['src'].libelle))
##     l.append("""</tr>""")

    # la destination
                
##         if matrix_model.dest_inv :
##             rule_elts['ip_dest'] = "! " + rule_elts['ip_dest']

##         l.append('<destination id="%s" extremite="%s" libelle="%s">'% \
##                  (rule_elts['dest'].name,
##                   rule_elts['dest'].zone.name,
##                   rule_elts['dest'].libelle))
##         l.append('<ip>%s</ip><netmask>%s</netmask><interface>%s</interface>' % \
##                  (rule_elts['ip_dest'], rule_elts['dest'].netmask, rule_elts['dest'].zone.interface))
##         l.append('</destination>')

##         # le service (ou la translation)
        
##         if matrix_model.serv_inv :
##             rule_elts['serv'].port_list[0] = "! " + str(rule_elts['serv'].port_list[0])
##         if rule_elts['type'] == 'std' : 
##             l.append(rule_elts['serv'].dump_rml())
##         elif rule_elts['type'] == 'icmp' :
##             l.append("<ping>%s</ping> " % rule_elts['serv'].name)
##         elif rule_elts['type'] == 'dnat' or rule_elts['type'] == 'redirect' :
##             l.append(rule_elts['serv'].write_as_translation(matrix_model.nat_port, "vers"))
##         elif rule_elts['type'] == 'masque' :
##             l.append(rule_elts['serv'].write_as_translation(matrix_model.nat_port, "en"))

##         # le redirige
##         if rule_elts['type'] == 'dnat' or rule_elts['type'] == 'masque' :
##             l.append('<redirige id="%s" extremite="%s" libelle="%s">'% \
##                      (rule_elts['nat_extr'].name,
##                       rule_elts['nat_extr'].zone.name,
##                       rule_elts['nat_extr'].libelle))
##             l.append('<ip>%s</ip><netmask>%s</netmask><interface>%s</interface>' % \
##                      (rule_elts['ip_nat'],
##                       rule_elts['nat_extr'].netmask,
##                       rule_elts['nat_extr'].zone.interface))
##             l.append('</redirige>')

##         # la balise conteneur fermante
##         # l.append("</%s>"% elt_name)

##     return "\n".join(l)
